# /packages/sencha-member-portlet/tcl/intranet-sencha-member-portlet-procs.tcl
#
# Copyright (C) 2003 - 2014 Project Open Business Solutions S.L.
#
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.
# 
# 

ad_library {
    @author klaus.hofeditz@project-open.com
}

# ---------------------------------------------------------------------
# Components  
# ---------------------------------------------------------------------

ad_proc -public im_project_copy_user_assignments {
    user_id
    { return_url "" }
} {
    Copies all project- and task-assignments from one user to another
	Helpful when an new employee is taking over assignments from a leaving employees. 
} {
    set params [list [list user_id $user_id] [list return_url $return_url]]
    set result [ad_parse_template -params $params "/packages/sencha-member-portlet/lib/copy-project-assignments"]
    return [string trim $result]
}


ad_proc -public im_project_bulk_assignment_component {
    { user_id }
    { return_url "" }
    { subproject_status_id "none"}
} {
    ExtJS based component showing a treepanel with all open projects.
    Allows users to assign members to multiple projects and sub-projects
    Does not (yet) allow task assignments

} {
    if {"" == $return_url} { set return_url [im_url_with_query] }
    set params [list [list return_url $return_url] [list user_id $user_id]]
    set result [ad_parse_template -params $params "/packages/sencha-member-portlet/lib/assign-users-to-projects"]
    return [string trim $result]
}
