Ext.define('POBASE.controller.ProjectTreePanel', {
    extend: 'Ext.app.Controller',
    refs: [{
        // COMPONENT QUERY -> get reference to the project Tree
        ref: 'myProjectTreePanel',
        selector: 'projectTreePanel'
    }],
    init: function () {
        this.control({
            'viewport': {
                render: this.onPanelRendered
            },
            //Tree events - click, checkbox change, node expand and right click
            'projectTreePanel': {
                itemclick: this.treeItemClick,
                checkchange: this.treeCheckChange,
                itemexpand: this.treeNodeExpand,
                itemcontextmenu: this.treeRightClick
            },
            //get all checked noded button
            'projectTreePanel button[action=saveRels]': {
                click: this.saveRels
            }
        });
    },
    
    onPanelRendered: function () {
        console.log('The panel was rendered');
    },
    
    saveRels: function (button) {

	// console.log('Clicked Button (saveRels) ...');
        selectedNodes = this.getMyProjectTreePanel().getChecked();

        // console.log('List of Selected Nodes:\n');
        // Ext.Array.each(selectedNodes, function (record) {
	//console.log('Node:' + record.get('id') + ' Text:' + record.get('project_name') + '\n');
        // });

	// var combo = Ext.getCmp('selectEmployeesCombo');
        
	Ext.Array.each(selectedNodes, function (record) {
            // console.log('Node:' + record.get('id') + ' Text:' + record.get('project_name') + '\n');

	    /* To be used when a DropDown is used to select the employee (selectEmployeesCombo)  
            Ext.each(combo.getValue(), function (item) {
                POBASE.controllers.get('Membership_rel').addUserProjectRel(item, record.get('id'));
            }); 
	    */

	    // To be used when user_id is provided as URL param
	    POBASE.controllers.get('Membership_rel').addUserProjectRel('@user_id;noquote@', record.get('id'));

        });

	Ext.getCmp('project-tree-panel-status').setStatus({
            iconCls: 'x-status-saved',
	    text: 'Assignments saved'
	});

    },

    //event triggered when a node is checked or unchecked
    treeCheckChange: function (node, checked) {
        console.log('Checkbox clicked: Is it checked? ' + checked);
        console.log('Is the node loaded? ' + node.isLoaded());
        //loops thru all child nodes and check or uncheck
        //based on the parent node that was clicked
        node.eachChild(function (childNode) {
            childNode.set('checked', checked);
            this.treeCheckChange(childNode, checked);
        }, this);
    },
    
    //node expand event
    treeNodeExpand: function (node) {
        console.log('Expanded Node: How many children? ' + node.childNodes.length);
    },
    
    //get all nodes that are checked in the Tree panel
    getAllCheckedNodes: function (button) {
        selectedNodes = this.getMyProjectTreePanel().getChecked();
        console.log('List of Selected Nodes:\n');
        Ext.Array.each(selectedNodes, function (record) {
            console.log('Node:' + record.get('id') + ' Text:' + record.get('project_name') + '\n');
        });
    },
    
    treeItemClick: function (view, record) {
        //some node in the tree was clicked, you have now access to the node record and the tree view
        // console.log('Clicked on a Tree Node!\n' + 'Node id: '
        //          + record.get('id') + '\n' + 'Node Text: '
        //          + record.get('project_name') + '\n' + 'Parent Node id: '
        //          + record.get('parentId') + '\n' + 'Is it a leaf?: '
        //          + record.get('leaf') + '\n' + 'No of Children: '
        //          + record.childNodes.length);
        //now you have all the information about the node: Node id, Node Text, Parent Node, Is node a leaf?, No of child nodes
    }
});
