// ~/packages/sencha-member-portlet/www/pobase/app/store/Projects.js
Ext.define('POBASE.store.Projects', {
    extend: 'Ext.data.TreeStore',
    model: POBASE.model.Project,
    autoScroll: true,
    pageParam: undefined,
    proxy: {
        type: 'ajax',
        url: '/intranet-rest/im_project',
        reader: {
            type: 'json',
            root: 'data'
        }
    },
    root: {
        text: 'Tree display of Projects',
        id: 'myTree',
        expanded: true
    },

    // folderSort: true,
    sorters: [{
        property: 'project_name',
        direction: 'ASC'
    }],

    listeners: {
        load: function (tree, node, records) {
	    // console.log('Projects.js::listeners::load:: ENTER ' + Date.now());
            if (node.get('checked')) {
                node.eachChild(function (childNode) {
                    childNode.set('checked', true);
                });
            };

	    // console.log('Projects.js::listeners::load:: Loading MembershipRels ... ' + Date.now());
	    Ext.getStore('EmployeeMembershipRels').load();
	    // console.log('Projects.js::listeners::load:: EmployeeMembershipRels loaded... ' + Date.now());
        },
	
        beforeload: function (store, operation, options) {
	    // console.log('Projects.js::listeners::beforeLoad:: ENTER:' + Date.now());

            // Adjust request URL to make it compatible with intranet-rest
            // Example: intranet-rest/im_project?format=json&query=project_status_id=76 and parent_id =
            // Get last index (example of an id (2nd level)): myTree/3456 -> last_id will be: 3456
            var last_id = operation.node.get('id').substr(operation.node.get('id').lastIndexOf('/') + 1);
            // console.log('last_id: ' + last_id);
            if ('myTree' == last_id) {
                store.getProxy().extraParams = {
                    query: 'project_status_id=76 and parent_id is null',
                    format: 'json',
                    columns: 'project_id_id,project_name'
                };
            }
            else {
                store.getProxy().extraParams = {
                    query: 'project_status_id=76 and parent_id=' + last_id,
                    format: 'json',
                    columns: 'project_id_id,project_name'
                };
            };
	    // console.log('Projects.js::listeners::beforeLoad:: LEAVING:' + Date.now());
        }
    }
}
);
