Ext.define('POBASE.store.Users', {
    extend: 'Ext.data.Store',
    model: 'POBASE.model.User',
    pageParam: undefined,
    pageSize: 999999999,
    // autoLoad: true,
    proxy: {
        type: 'ajax',
        url: '/intranet-rest/user',
        pageParam: undefined,
        extraParams: {
            format: 'json',
            columns: 'user_id,first_names,last_name,email'
        },
        reader: {
            type: 'json',
            root: 'data'
        }
    },
    listeners: {
        load: function (store, records, success) {
            if (!success) {
                Ext.MessageBox.alert('Error', "Error retrieving User data. Your session might be expired, please <a href='/register/?return_url=<%=[im_url_with_query]%>'>re-login</a>");
            } else {
		// console.log('POBASE.store.Users: Filling Employee Store ... ' + Date.now());
		POBASE.controllers.get('Employees').fillEmployeeStoreFromUserStore();
		// console.log('POBASE.store.Users  Employee Store filled ... ' + Date.now());
	    };
            // If there's a EmployeeMembershipRels store load it
            // Ext.getCmp('project-tree-panel-status').showBusy('Loading membership relationships...');
            // if (Ext.getStore('EmployeeMembershipRels')) {
            // console.log('Found store EmployeeMembershipRels, loading now ...');
            // Ext.getStore('EmployeeMembershipRels').load();
            // };
        }
    },
    sorters: [{
        property: 'last_name',
        direction: 'ASC'
    }]
});
