# /packages/sencha-member-portlet/www/xhr-biz-object-add-role.tcl

# Copyright (c) 2014 Project Open Business Solutions S.L.
# All rights reserved. Please check
# http://www.project-open.com/license/ for details.
# 
# @author klaus.hofeditz@project-open.com

ad_page_contract {
    Copies project & sub-project relationships from one user to another  

    @param from_user  
    @param to_user 

    @author klaus.hofeditz@project-open.com
} {
    { user_id:integer }
    { object_id:integer }
    { role_id:integer }
}

set current_user_id [auth::require_login]

# Check permissions 
set object_type [db_string acs_object_type "select object_type from acs_objects where object_id=:object_id" -default ""]
if {"" == $object_type} { ad_return_complaint 1 "<b>Didn't find object with id #$object_id</b>:<br>Maybe the object has been deleted?" }
set perm_cmd "${object_type}_permissions \$current_user_id \$object_id view read write admin"
eval $perm_cmd

if {!$write} { 
    ns_return 500 text/html "Error setting membership; no WRITE permissions"
} 

if { 0 != [im_biz_object_add_role $user_id $object_id $role_id] } {
	ns_return 200 text/html 1
} else {
	ns_return 500 text/html "Error setting membership, function: im_biz_object_add_role failed. Please contact your System Administrator"
}
